clang 10.0.0git

Public Member Functions | Static Public Member Functions | Friends | List of all members
clang::OMPOrderedClause Class Referencefinal

This represents 'ordered' clause in the '#pragma omp ...' directive. More...

`#include "clang/AST/OpenMPClause.h"`

Inheritance diagram for clang::OMPOrderedClause:
[legend]
Collaboration diagram for clang::OMPOrderedClause:
[legend]

## Public Member Functions
void | setLParenLoc (SourceLocation Loc)
| Sets the location of '('. More...
SourceLocation | getLParenLoc () const
| Returns the location of '('. More...
Expr * | getNumForLoops () const
| Return the number of associated for-loops. More...
void | setLoopNumIterations (unsigned NumLoop, Expr *NumIterations)
| Set number of iterations for the specified loop. More...
ArrayRef< Expr * > | getLoopNumIterations () const
| Get number of iterations for all the loops. More...
void | setLoopCounter (unsigned NumLoop, Expr *Counter)
| Set loop counter for the specified loop. More...
Expr * | getLoopCounter (unsigned NumLoop)
| Get loops counter for the specified loop. More...
const Expr * | getLoopCounter (unsigned NumLoop) const
child_range | children ()
const_child_range | children () const
child_range | used_children ()
const_child_range | used_children () const
Public Member Functions inherited from clang::OMPClause
SourceLocation | getBeginLoc () const
| Returns the starting location of the clause. More...
SourceLocation | getEndLoc () const
| Returns the ending location of the clause. More...
void | setLocStart (SourceLocation Loc)
| Sets the starting location of the clause. More...
void | setLocEnd (SourceLocation Loc)
| Sets the ending location of the clause. More...
OpenMPClauseKind | getClauseKind () const
| Returns kind of OpenMP clause (private, shared, reduction, etc.). More...
bool | isImplicit () const
child_range | children ()
const_child_range | children () const
child_range | used_children ()
| Get the iterator range for the expressions used in the clauses. More...
const_child_range | used_children () const

## Static Public Member Functions
static OMPOrderedClause * | Create (const ASTContext &C, Expr *Num, unsigned NumLoops, SourceLocation StartLoc, SourceLocation LParenLoc, SourceLocation EndLoc)
| Build 'ordered' clause. More...
static OMPOrderedClause * | CreateEmpty (const ASTContext &C, unsigned NumLoops)
| Build an empty clause. More...
static bool | classof (const OMPClause *T)
Static Public Member Functions inherited from clang::OMPClause
static bool | classof (const OMPClause *)

## Friends
class | OMPClauseReader

## Additional Inherited Members
Public Types inherited from clang::OMPClause
using | child_iterator = StmtIterator
using | const_child_iterator = ConstStmtIterator
using | child_range = llvm::iterator_range< child_iterator >
using | const_child_range = llvm::iterator_range< const_child_iterator >
Protected Member Functions inherited from clang::OMPClause
| OMPClause (OpenMPClauseKind K, SourceLocation StartLoc, SourceLocation EndLoc)

## Detailed Description

This represents 'ordered' clause in the '#pragma omp ...' directive.

#pragma omp for ordered (2)

In this example directive '#pragma omp for' has 'ordered' clause with parameter 2.

Definition at line 1474 of file OpenMPClause.h.

## Member Function Documentation

## ◆ children() [1/2]

child_range clang::OMPOrderedClause::children | ( |  | ) |
| inline

Definition at line 1545 of file OpenMPClause.h.

## ◆ children() [2/2]

const_child_range clang::OMPOrderedClause::children | ( |  | ) | const
| inline

Definition at line 1547 of file OpenMPClause.h.

## ◆ classof()

static bool clang::OMPOrderedClause::classof | ( | const OMPClause * | T | ) |
| inline static

Definition at line 1558 of file OpenMPClause.h.

References clang::OMPClause::getClauseKind().

## ◆ Create()

OMPOrderedClause * OMPOrderedClause::Create | ( | const ASTContext & | C,
|  | Expr * | Num,
|  | unsigned | NumLoops,
|  | SourceLocation | StartLoc,
|  | SourceLocation | LParenLoc,
|  | SourceLocation | EndLoc
| ) |  |
| static

Build 'ordered' clause.

Parameters

  Num | Expression, possibly associated with this clause.
  NumLoops | Number of loops, associated with this clause.
  StartLoc | Starting location of the clause.
  LParenLoc | Location of '('.
  EndLoc | Ending location of the clause.

Definition at line 268 of file OpenMPClause.cpp.

References clang::ASTContext::Allocate(), and setLoopNumIterations().

Referenced by clang::Sema::ActOnOpenMPOrderedClause().

## ◆ CreateEmpty()

OMPOrderedClause * OMPOrderedClause::CreateEmpty | ( | const ASTContext & | C,
|  | unsigned | NumLoops
| ) |  |
| static

Build an empty clause.

Definition at line 283 of file OpenMPClause.cpp.

References clang::ASTContext::Allocate(), and setLoopNumIterations().

## ◆ getLoopCounter() [1/2]

Expr * OMPOrderedClause::getLoopCounter | ( | unsigned | NumLoop | ) |

Get loops counter for the specified loop.

Definition at line 309 of file OpenMPClause.cpp.

Referenced by clang::ASTRecordWriter::writeOMPClause().

## ◆ getLoopCounter() [2/2]

const Expr * OMPOrderedClause::getLoopCounter | ( | unsigned | NumLoop | ) | const

Definition at line 314 of file OpenMPClause.cpp.

## ◆ getLoopNumIterations()

ArrayRef< Expr * > OMPOrderedClause::getLoopNumIterations | ( |  | ) | const

Get number of iterations for all the loops.

Definition at line 300 of file OpenMPClause.cpp.

Referenced by clang::ASTRecordWriter::writeOMPClause().

## ◆ getLParenLoc()

SourceLocation clang::OMPOrderedClause::getLParenLoc | ( |  | ) | const
| inline

Returns the location of '('.

Definition at line 1529 of file OpenMPClause.h.

Referenced by clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ getNumForLoops()

Expr* clang::OMPOrderedClause::getNumForLoops | ( |  | ) | const
| inline

Return the number of associated for-loops.

Definition at line 1532 of file OpenMPClause.h.

Referenced by OMPNontemporalClause::setPrivateRefs(), clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ setLoopCounter()

void OMPOrderedClause::setLoopCounter | ( | unsigned | NumLoop,
|  | Expr * | Counter
| ) |  |

Set loop counter for the specified loop.

Definition at line 304 of file OpenMPClause.cpp.

Referenced by clang::OMPClauseReader::VisitOMPClauseWithPostUpdate().

## ◆ setLoopNumIterations()

void OMPOrderedClause::setLoopNumIterations | ( | unsigned | NumLoop,
|  | Expr * | NumIterations
| ) |  |

Set number of iterations for the specified loop.

Definition at line 294 of file OpenMPClause.cpp.

Referenced by Create(), CreateEmpty(), and clang::OMPClauseReader::VisitOMPClauseWithPostUpdate().

## ◆ setLParenLoc()

void clang::OMPOrderedClause::setLParenLoc | ( | SourceLocation | Loc | ) |
| inline

Sets the location of '('.

Definition at line 1526 of file OpenMPClause.h.

Referenced by clang::OMPClauseReader::VisitOMPClauseWithPostUpdate().

## ◆ used_children() [1/2]

child_range clang::OMPOrderedClause::used_children | ( |  | ) |
| inline

Definition at line 1551 of file OpenMPClause.h.

## ◆ used_children() [2/2]

const_child_range clang::OMPOrderedClause::used_children | ( |  | ) | const
| inline

Definition at line 1554 of file OpenMPClause.h.

## Friends And Related Function Documentation

## ◆ OMPClauseReader

friend class OMPClauseReader
| friend

Definition at line 1477 of file OpenMPClause.h.

The documentation for this class was generated from the following files:

- include/clang/AST/OpenMPClause.h
- lib/AST/OpenMPClause.cpp